# GstGLUpload

GstGLUpload is an object that uploads data from system memory into GL textures.

A GstGLUpload can be created with gst_gl_upload_new

## GstGLUpload

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstGLUpload

Opaque GstGLUpload object

### Members

`parent` (GstObject) –
No description available
`context` (GstGLContext *) –
No description available

### Class structure

#### GstGLUploadClass

The GstGLUploadClass struct only contains private data

##### Fields

`object_class` (GstObjectClass) –
No description available

### GstGL.GLUploadClass

The GstGL.GLUploadClass struct only contains private data

##### Attributes

`object_class` (Gst.ObjectClass) –
No description available

### GstGL.GLUploadClass

The GstGL.GLUploadClass struct only contains private data

##### Attributes

`object_class` (Gst.ObjectClass) –
No description available

## GstGL.GLUpload

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──GstGL.GLUpload

Opaque GstGL.GLUpload object

### Members

`parent` (Gst.Object) –
No description available
`context` (GstGL.GLContext) –
No description available

## GstGL.GLUpload

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──GstGL.GLUpload

Opaque GstGL.GLUpload object

### Members

`parent` (Gst.Object) –
No description available
`context` (GstGL.GLContext) –
No description available

### Constructors

#### gst_gl_upload_new

    GstGLUpload *
    gst_gl_upload_new (GstGLContext * context)

Parameters:

`context` –

a GstGLContext

Returns ( [transfer: full]) –

a new GstGLUpload object

#### GstGL.GLUpload.prototype.new

    function GstGL.GLUpload.prototype.new(context: GstGL.GLContext): {
        // javascript wrapper for 'gst_gl_upload_new'
    }

Parameters:

`context` (GstGL.GLContext) –

a GstGL.GLContext

Returns (GstGL.GLUpload) –

a new GstGL.GLUpload object

#### GstGL.GLUpload.new

    def GstGL.GLUpload.new (context):
        #python wrapper for 'gst_gl_upload_new'

Parameters:

`context` (GstGL.GLContext) –

a GstGL.GLContext

Returns (GstGL.GLUpload) –

a new GstGL.GLUpload object

### Methods

#### gst_gl_upload_fixate_caps

    GstCaps *
    gst_gl_upload_fixate_caps (GstGLUpload * upload,
                               GstPadDirection direction,
                               GstCaps * caps,
                               GstCaps * othercaps)

Fixate the othercaps based on the information of the caps.

Parameters:

`upload` –

a GstGLUpload

`direction` –

the pad GstPadDirection

`caps` –

a GstCaps as the reference

`othercaps` ( [transfer: full]) –

a GstCaps to fixate

Returns ( [transfer: full]) –

the fixated caps

Since : 1.24

#### GstGL.GLUpload.prototype.fixate_caps

    function GstGL.GLUpload.prototype.fixate_caps(direction: Gst.PadDirection, caps: Gst.Caps, othercaps: Gst.Caps): {
        // javascript wrapper for 'gst_gl_upload_fixate_caps'
    }

Fixate the othercaps based on the information of the caps.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`direction` (Gst.PadDirection) –

the pad Gst.PadDirection

`caps` (Gst.Caps) –

a Gst.Caps as the reference

`othercaps` (Gst.Caps) –

a Gst.Caps to fixate

Returns (Gst.Caps) –

the fixated caps

Since : 1.24

#### GstGL.GLUpload.fixate_caps

    def GstGL.GLUpload.fixate_caps (self, direction, caps, othercaps):
        #python wrapper for 'gst_gl_upload_fixate_caps'

Fixate the othercaps based on the information of the caps.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`direction` (Gst.PadDirection) –

the pad Gst.PadDirection

`caps` (Gst.Caps) –

a Gst.Caps as the reference

`othercaps` (Gst.Caps) –

a Gst.Caps to fixate

Returns (Gst.Caps) –

the fixated caps

Since : 1.24

#### gst_gl_upload_get_caps

    gst_gl_upload_get_caps (GstGLUpload * upload,
                            GstCaps ** in_caps,
                            GstCaps ** out_caps)

Parameters:

`upload` –

a GstGLUpload

`in_caps` ( [transfer: full][allow-none][out]) –

the input GstCaps

`out_caps` ( [transfer: full][allow-none][out]) –

the output GstCaps

#### GstGL.GLUpload.prototype.get_caps

    function GstGL.GLUpload.prototype.get_caps(): {
        // javascript wrapper for 'gst_gl_upload_get_caps'
    }

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

#### GstGL.GLUpload.get_caps

    def GstGL.GLUpload.get_caps (self):
        #python wrapper for 'gst_gl_upload_get_caps'

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

#### gst_gl_upload_perform_with_buffer

    GstGLUploadReturn
    gst_gl_upload_perform_with_buffer (GstGLUpload * upload,
                                       GstBuffer * buffer,
                                       GstBuffer ** outbuf_ptr)

Uploads buffer using the transformation specified by gst_gl_upload_set_caps creating a new GstBuffer in outbuf_ptr.

Parameters:

`upload` –

a GstGLUpload

`buffer` –

input GstBuffer

`outbuf_ptr` ( [out]) –

resulting GstBuffer

Returns –

whether the upload was successful

#### GstGL.GLUpload.prototype.perform_with_buffer

    function GstGL.GLUpload.prototype.perform_with_buffer(buffer: Gst.Buffer): {
        // javascript wrapper for 'gst_gl_upload_perform_with_buffer'
    }

Uploads buffer using the transformation specified by GstGL.GLUpload.prototype.set_caps creating a new Gst.Buffer in outbuf_ptr.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`buffer` (Gst.Buffer) –

input Gst.Buffer

Returns a tuple made of:

(GstGL.GLUploadReturn ) –

whether the upload was successful

`outbuf_ptr` (Gst.Buffer ) –

whether the upload was successful

#### GstGL.GLUpload.perform_with_buffer

    def GstGL.GLUpload.perform_with_buffer (self, buffer):
        #python wrapper for 'gst_gl_upload_perform_with_buffer'

Uploads buffer using the transformation specified by GstGL.GLUpload.set_caps creating a new Gst.Buffer in outbuf_ptr.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`buffer` (Gst.Buffer) –

input Gst.Buffer

Returns a tuple made of:

(GstGL.GLUploadReturn ) –

whether the upload was successful

`outbuf_ptr` (Gst.Buffer ) –

whether the upload was successful

#### gst_gl_upload_propose_allocation

    gst_gl_upload_propose_allocation (GstGLUpload * upload,
                                      GstQuery * decide_query,
                                      GstQuery * query)

Adds the required allocation parameters to support uploading.

Parameters:

`upload` –

a GstGLUpload

`decide_query` ( [allow-none]) –

a GstQuery from a decide allocation

`query` –

the proposed allocation query

#### GstGL.GLUpload.prototype.propose_allocation

    function GstGL.GLUpload.prototype.propose_allocation(decide_query: Gst.Query, query: Gst.Query): {
        // javascript wrapper for 'gst_gl_upload_propose_allocation'
    }

Adds the required allocation parameters to support uploading.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`decide_query` (Gst.Query) –

a Gst.Query from a decide allocation

`query` (Gst.Query) –

the proposed allocation query

#### GstGL.GLUpload.propose_allocation

    def GstGL.GLUpload.propose_allocation (self, decide_query, query):
        #python wrapper for 'gst_gl_upload_propose_allocation'

Adds the required allocation parameters to support uploading.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`decide_query` (Gst.Query) –

a Gst.Query from a decide allocation

`query` (Gst.Query) –

the proposed allocation query

#### gst_gl_upload_set_caps

    gboolean
    gst_gl_upload_set_caps (GstGLUpload * upload,
                            GstCaps * in_caps,
                            GstCaps * out_caps)

Initializes upload with the information required for upload.

Parameters:

`upload` –

a GstGLUpload

`in_caps` –

input GstCaps

`out_caps` –

output GstCaps

Returns –

whether in_caps and out_caps could be set on upload

#### GstGL.GLUpload.prototype.set_caps

    function GstGL.GLUpload.prototype.set_caps(in_caps: Gst.Caps, out_caps: Gst.Caps): {
        // javascript wrapper for 'gst_gl_upload_set_caps'
    }

Initializes upload with the information required for upload.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`in_caps` (Gst.Caps) –

input Gst.Caps

`out_caps` (Gst.Caps) –

output Gst.Caps

Returns (Number) –

whether in_caps and out_caps could be set on upload

#### GstGL.GLUpload.set_caps

    def GstGL.GLUpload.set_caps (self, in_caps, out_caps):
        #python wrapper for 'gst_gl_upload_set_caps'

Initializes upload with the information required for upload.

Parameters:

`upload` (GstGL.GLUpload) –

a GstGL.GLUpload

`in_caps` (Gst.Caps) –

input Gst.Caps

`out_caps` (Gst.Caps) –

output Gst.Caps

Returns (bool) –

whether in_caps and out_caps could be set on upload

#### gst_gl_upload_set_context

    gst_gl_upload_set_context (GstGLUpload * upload,
                               GstGLContext * context)

Parameters:

`upload` –
No description available
`context` –
No description available

#### GstGL.GLUpload.prototype.set_context

    function GstGL.GLUpload.prototype.set_context(context: GstGL.GLContext): {
        // javascript wrapper for 'gst_gl_upload_set_context'
    }

Parameters:

`upload` (GstGL.GLUpload) –
No description available
`context` (GstGL.GLContext) –
No description available

#### GstGL.GLUpload.set_context

    def GstGL.GLUpload.set_context (self, context):
        #python wrapper for 'gst_gl_upload_set_context'

Parameters:

`upload` (GstGL.GLUpload) –
No description available
`context` (GstGL.GLContext) –
No description available

#### gst_gl_upload_transform_caps

    GstCaps *
    gst_gl_upload_transform_caps (GstGLUpload * upload,
                                  GstGLContext * context,
                                  GstPadDirection direction,
                                  GstCaps * caps,
                                  GstCaps * filter)

Parameters:

`upload` –
No description available
`context` –
No description available
`direction` –
No description available
`caps` –
No description available
`filter` –
No description available
Returns –
No description available

#### GstGL.GLUpload.prototype.transform_caps

    function GstGL.GLUpload.prototype.transform_caps(context: GstGL.GLContext, direction: Gst.PadDirection, caps: Gst.Caps, filter: Gst.Caps): {
        // javascript wrapper for 'gst_gl_upload_transform_caps'
    }

Parameters:

`upload` (GstGL.GLUpload) –
No description available
`context` (GstGL.GLContext) –
No description available
`direction` (Gst.PadDirection) –
No description available
`caps` (Gst.Caps) –
No description available
`filter` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

#### GstGL.GLUpload.transform_caps

    def GstGL.GLUpload.transform_caps (self, context, direction, caps, filter):
        #python wrapper for 'gst_gl_upload_transform_caps'

Parameters:

`upload` (GstGL.GLUpload) –
No description available
`context` (GstGL.GLContext) –
No description available
`direction` (Gst.PadDirection) –
No description available
`caps` (Gst.Caps) –
No description available
`filter` (Gst.Caps) –
No description available
Returns (Gst.Caps) –
No description available

### Functions

#### gst_gl_upload_get_input_template_caps

    GstCaps *
    gst_gl_upload_get_input_template_caps ()

Returns –
No description available

#### GstGL.GLUpload.prototype.get_input_template_caps

    function GstGL.GLUpload.prototype.get_input_template_caps(): {
        // javascript wrapper for 'gst_gl_upload_get_input_template_caps'
    }

Returns (Gst.Caps) –
No description available

#### GstGL.GLUpload.get_input_template_caps

    def GstGL.GLUpload.get_input_template_caps ():
        #python wrapper for 'gst_gl_upload_get_input_template_caps'

Returns (Gst.Caps) –
No description available

## Function Macros

### GST_GL_UPLOAD_CAST

    #define GST_GL_UPLOAD_CAST(obj) ((GstGLUpload*)(obj))

## Enumerations

### GstGLUploadReturn

##### Members

`GST_GL_UPLOAD_DONE` (1) –

No further processing required

`GST_GL_UPLOAD_ERROR` (-1) –

An unspecified error occurred

`GST_GL_UPLOAD_UNSUPPORTED` (-2) –

The configuration is unsupported.

`GST_GL_UPLOAD_RECONFIGURE` (-3) –

This element requires a reconfiguration.

`GST_GL_UPLOAD_UNSHARED_GL_CONTEXT` (-100) –

private return value.

### GstGL.GLUploadReturn

##### Members

`GstGL.GLUploadReturn.DONE` (1) –

No further processing required

`GstGL.GLUploadReturn.ERROR` (-1) –

An unspecified error occurred

`GstGL.GLUploadReturn.UNSUPPORTED` (-2) –

The configuration is unsupported.

`GstGL.GLUploadReturn.RECONFIGURE` (-3) –

This element requires a reconfiguration.

`GstGL.GLUploadReturn.UNSHARED_GL_CONTEXT` (-100) –

private return value.

### GstGL.GLUploadReturn

##### Members

`GstGL.GLUploadReturn.DONE` (1) –

No further processing required

`GstGL.GLUploadReturn.ERROR` (-1) –

An unspecified error occurred

`GstGL.GLUploadReturn.UNSUPPORTED` (-2) –

The configuration is unsupported.

`GstGL.GLUploadReturn.RECONFIGURE` (-3) –

This element requires a reconfiguration.

`GstGL.GLUploadReturn.UNSHARED_GL_CONTEXT` (-100) –

private return value.

The results of the search are